UNIT RTL;

{$mode objfpc}{$H+}

INTERFACE

  FUNCTION _DIV(CONST x, y: INT64): INT64;
  FUNCTION _MOD(CONST x, y: INT64): INT64;
  FUNCTION _RTI(CONST r: Extended): INT64;
  FUNCTION _ITR(CONST i: INT64): Extended;

IMPLEMENTATION

FUNCTION _DIV(CONST x, y: INT64): INT64;
VAR
  Q,R: INT64;
BEGIN
  Q:=TRUNC(x/y);
  R:=x MOD y;
  IF R<0 THEN BEGIN
    IF y>0 THEN
      Q:=Q-1
    ELSE
      Q:=Q+1;
  END;
  RESULT := Q;
END;

FUNCTION _MOD(CONST x, y: INT64): INT64;
BEGIN
  ASSERT(y > 0);
  IF x >= 0 THEN
    RESULT := x MOD y
  ELSE
    RESULT := (y + (x MOD y)) MOD y;
END;

FUNCTION _RTI(CONST r: Extended): INT64;
VAR
  i: INT64 ABSOLUTE r;
BEGIN
  RESULT := i;
END;

FUNCTION _ITR(CONST i: INT64): Extended;
VAR
  r: Extended ABSOLUTE i;
BEGIN
  RESULT := r;
END;

END.


